#!/bin/bash

# directory of the script (for finding the patch)
DIR="$( cd "$( dirname "${BASH_SOURCE[0]}" )" && pwd )"

# install latest kernel
sudo apt-get update
sudo apt-get install -y linux-image-$(uname -r) linux-headers-$(uname -r)

# download kernel source
mkdir /tmp/kernel
pushd /tmp/kernel 
apt-get source linux-headers-$(uname -r)

# apply patch
pushd linux-*
patch -p1 < $DIR/hid_driver_patch 

# install possible build dependencies
sudo apt-get install -y devscripts build-essential wget fakeroot cdbs patchutils debhelper
sudo apt-get build-dep -y linux-headers-$(uname -r)

# build new drivers
pushd drivers/hid
make -C /usr/src/linux-headers-`uname -r` M=`pwd` modules

# install new drivers
sudo make -C /usr/src/linux-headers-`uname -r` M=`pwd` modules_install

# make sure new drivers are loaded
sudo cp $DIR/ubuntu.conf /etc/depmod.d/
sudo depmod -a
sudo update-initramfs -u
popd

# get rid of evidence
popd
popd
rm -rf /tmp/kernel

echo "kernel driver build and install complete"
